      ****************************************************************          
      *                                                                         
      * TuVXeFwwwwVXe                                        
      *                                                                         
      * vOhcFɃgUNV                                
      *                                                                         
      * @\Tv F                                                             
      *                                                                         
      *                                                                         
      * 쐬 F                                                               
      * 쐬 F                                                               
      * ύX Ft       e                                          
      *                                                                         
      ****************************************************************          
       IDENTIFICATION      DIVISION.                                            
       PROGRAM-ID.         TESTCOPY.                                            
      *                                                                         
       ENVIRONMENT         DIVISION.                                            
       CONFIGURATION       SECTION.                                             
           SOURCE-COMPUTER.                                                     
           OBJECT-COMPUTER.                                                     
      *                                                                         
       INPUT-OUTPUT        SECTION.                                             
       FILE-CONTROL.                                                            
           SELECT  INFILE  ASSIGN TO  XINFILE.                                  
           SELECT  OUTFILE ASSIGN TO  XOUTFILE.                                 
      *                                                                         
       DATA                DIVISION.                                            
       FILE                SECTION.                                             
       FD  INFILE                                                               
           BLOCK CONTAINS 0 RECORDS.                                            
       01  INFILE-REC.                                                          
           COPY  NIUGOKI  REPLACING  ==XX-== BY ==IN-==                         
                                     'NYUKO-' BY NYUKO-.                        
           03  IN-DATE.                                                         
            05  IN-YYYY     PIC 9(4).                                           
            05  IN-MM       PIC 99.                                             
            05  IN-DD       PIC 99.                                             
       FD  OUTFILE                                                              
           BLOCK CONTAINS 0 RECORDS.                                            
       01  OUTFILE-REC.                                                         
           COPY  NIUGOKI  REPLACING  ==XX-== BY ==OT-==                         
                                     'NYUKO-' BY SYUKKO-.                       
           03  OT-DATE.                                                         
            05  OT-YYYY     PIC 9(4).                                           
            05  OT-MM       PIC 99.                                             
            05  OT-DD       PIC 99.                                             
      *                                                                         
       WORKING-STORAGE SECTION.                                                 
      *----[NGA----------------------------------------------*          
       77  F-PROCESS-END             PIC  X(01)  VALUE SPACE. 
       77  WK-COMMENT                PIC  X(08).                  
       77  DUMMY                                                                
           COPY  COPYPIC                                                        
           COPY  COPYVALUE                                                      
           COPY  COPYUSAGE                                                      
           BLANK WHEN ZERO.                                                     
       01  MSG-AREA  VALUE  SPACE.                                              
           03  MSG-DATE     PIC X(08).                                          
       01  TAB.                                                                 
           03  TABX  OCCURS 10 TIMES.                                           
            05  TAB-A       PIC X(02).                                          
       01  PRODUCT-TAB.
           03  FILLER  PIC  X(10)  VALUE '11'.
           03  FILLER  PIC  X(10)  VALUE '22'.
           03  FILLER  PIC  X(10)  VALUE '33'.
           03  FILLER  PIC  X(10)  VALUE '44ۑHi'.
           03  FILLER  PIC  X(10)  VALUE '55'.
       01  PRODUCT-TABX  REDEFINES  PRODUCT-TAB.
           03  PRODUCT-EACH  OCCURS 5 TIMES  INDEXED BY IX1.
            05  PRODUCT-CODE     PIC  XX.
            05  PRODUCT-COMMENT  PIC X(08).
      /***************************************************************          
      *                            VER(0.0)                                     
      ****************************************************************          
       PROCEDURE           DIVISION.               
       DECLARATIVES.
       EXCEPTION-INFILE-ERROR     SECTION.
           USE AFTER STANDARD ERROR PROCEDURE ON INFILE.
           DISPLAY  'INFILE ̓G['.
       EXCEPTION-OUTFILE-ERROR     SECTION.
           USE AFTER STANDARD ERROR PROCEDURE ON INFILE.
           DISPLAY  'INFILE ̓G['.
       END DECLARATIVES.                             
       MAIN                SECTION.                                             
       MAIN-START.                                                              
           PERFORM  INIT-SEC.                                                   
           PERFORM  PROCESS-SEC  UNTIL F-PROCESS-END = '*'.                     
           PERFORM  FINAL-SEC.                                                  
      *                                                                         
       MAIN-EXIT.                                                               
           STOP RUN.                                                            
      ****************************************************************          
      *                                                             
      ****************************************************************          
       INIT-SEC            SECTION.                                             
           DISPLAY  'TESTCOPY   START!!'.                                       
           OPEN  INPUT  INFILE.                                                 
           OPEN  OUTPUT OUTFILE.                                                
       INIT-SEC-EXIT.                                                           
           EXIT.                                                                
      ****************************************************************          
      * 又                                                              
      ****************************************************************          
       PROCESS-SEC         SECTION.                                             
           READ  INFILE                                                         
             AT END  MOVE  '*'  TO  F-PROCESS-END                               
                     GO TO  PROCESS-SEC-EXIT                                    
           END-READ.                                                            
           MOVE  IN-TRAN-ID        TO  OT-TRAN-ID.                              
           MOVE  IN-STORE-CODE     TO  OT-STORE-CODE.                           
           MOVE  IN-PRODUCT-CODE   TO  OT-PRODUCT-CODE.                         
           MOVE  IN-VOLUME         TO  OT-VOLUME.                               
       PROCESS-02.                                                              
           CALL  'SUB001'  USING                                                
                 COPY  SUB001P                                                  
                       REPLACING IN-DATE BY IN-DATE OF INFILE-REC               
                                 KUBUN   BY TAB-A(1)                            
                           F-PROCESS-END.                                       
           MOVE  IN-DATE OF INFILE-REC    TO  OT-SYUKKO-DATE.                   
           PERFORM  EDIT-01  THRU  EDIT-04.                                     
           WRITE  OUTFILE-REC.                                                  
       PROCESS-SEC-EXIT.                                                        
           EXIT.                                                                
      ****************************************************************          
      * I                                                            
      ****************************************************************          
       FINAL-SEC           SECTION.                                             
           CLOSE  INFILE  OUTFILE.                                              
           DISPLAY  'TESTCOPY   END!!'.                                         
           DISPLAY  MSG-DATE OF MSG-AREA.                                       
       FINAL-SEC-EXIT.                                                          
           EXIT.                                                                
      ****************************************************************          
      * ҏW                                                        
      ****************************************************************          
       EDIT-01             SECTION.                                             
           MOVE  SPACE     TO  OUTFILE-REC.                                     
           MOVE  IN-TRAN-ID            TO  OT-TRAN-ID.                          
       EDIT-02             SECTION.                                             
           MOVE  IN-STORE-CODE         TO  OT-STORE-CODE.                       
       EDIT-03             SECTION.                                             
           MOVE  IN-VOLUME             TO  OT-VOLUME.                           
           MOVE  ZERO                  TO  OT-SYUKKO-DATE.                      
       EDIT-04             SECTION.                                             
           MOVE  CAR-NO OF INFILE-REC  TO  CAR-NO OF OUTFILE-REC.               
           MOVE  TRACKING-NO OF INFILE-REC                                      
                   TO  TRACKING-NO OF OUTFILE-REC.                              
           MOVE  TRACKING-DATE OF INFILE-REC                                    
                   TO  TRACKING-DATE OF OUTFILE-REC.                            
       EDIT-OUTFILE-EXIT.                                                       
           EXIT.                                                                
      ****************************************************************          
      * I                                                            
      ****************************************************************          
       SEARCH-SEC           SECTION.                                             
           SET IX1  TO  1.
           SEARCH  PRODUCT-EACH  VARYING IX1
             AT END  DISPLAY 'SEARCH ERROR'
             WHEN  PRODUCT-CODE(IX1) = IN-PRODUCT-CODE(1:2)
                   MOVE  PRODUCT-COMMENT(IX1)  TO  WK-COMMENT
           END-SEARCH.                      
       SEARCH-EXIT.                                                          
           EXIT.                                                                
